#ifndef COMMON_H_
#define COMMON_H_

#include <math.h>

const int    NAMEL = 200;             // reserved string length for file names
const int    INTERM = 10;             // evaluate rmsd/chisquare convergence every INTERM steps
const int    CONN_Threshold = 40;     // evaluate connectivity convergence every CONN_Threshold steps
const int    SeedA0 = 123456789;      // seed for randomlizing matrix A
const int    SeedP0 = 876543212;      // seed for randomlizing matrix P
const double AcceptedDiff = 1.0e-5;   // the minimum meaningful difference between D and Mock element
const double eps = 1.0e-10;           // precision control
const double UPPERLIMIT = 50.0;       // upper limit cut for exponential power
const double weight = 0.5;            // weight scale for prior information if appliable


class Common

{
     public:
	  int    Zscoring(double *original, double *zscore, int n);
	  int    Zscoring(double *original, int offset, double *zscore, int n);
	  double ran2(long *);
};

#endif
