#include "L.h"

using namespace std;

////////////////////////////////////////////////////
L::L(int npatterns, JNIEnv *e, jobject o, jobject b)
////////////////////////////////////////////////////
     
{
  int  i;
  env = e;
  obj = o;
  BDout = b;
  cls = env->GetObjectClass(obj);
  meth = env->GetMethodID(cls,"guiPrint","(Ljava/lang/String;)V");
  
  Npatterns = npatterns;
}

////////////////////////////////////////////////////
L::L(JNIEnv *e, jobject o, jobject b)
////////////////////////////////////////////////////
     
{
  env = e;
  obj = o;
  BDout = b;
  cls = env->GetObjectClass(obj);
  meth = env->GetMethodID(cls,"guiPrint","(Ljava/lang/String;)V");
}

////////////////////////////////////////////////
int L::AllocateMemory()
////////////////////////////////////////////////
	

{
	int i;

	// allocate memory for mandatory matrixes
	Mock        = new double[Ngenes * Nsamples];
	Amplitude   = new double[Ngenes * Npatterns];
	A_Weights   = new double[Ngenes * Npatterns];
	Pattern     = new double[Npatterns * Nsamples];
	P_Weights   = new double[Npatterns * Nsamples];
	ScannedA    = new int[Ngenes * Npatterns];
	ScannedP    = new int[Npatterns * Nsamples];
	normalizedP = new double[Npatterns * Nsamples];

	if(ConnectivityCheck) 
	{
		connectivity = new int[Nsamples*Nsamples];
		connectivity0 = new int[Nsamples*Nsamples];
	}

	return(1);
}

/////////////////////////////////////////////////////
L::~L()
/////////////////////////////////////////////////////
	
{
}

/////////////////////////////////////////////
int L::Initialization()
/////////////////////////////////////////////

{
	int  i, j;

	// Intialize component matrixes
	SeedA = RandomlizeMatrix(Amplitude, 'A');
	SeedP = RandomlizeMatrix(Pattern, 'P');
	// for (i=0; i<Ngenes; i++) for (j=0; j<Npatterns; j++) Amplitude[i * Npatterns + j] = 0.0;
	// for (i=0; i<Npatterns; i++) for (j=0; j<Nsamples; j++) Pattern[i * Nsamples + j] = 0.0;

	return(1);
}

////////////////////////////////////////////////////
int L::Initialization(char *afile, char *pfile)
////////////////////////////////////////////////////

{
	int  i, j;

	// Intialize component matrixes
	ReadMatrix(Amplitude, afile, Ngenes, Npatterns);
	ReadMatrix(Pattern, pfile, Npatterns, Nsamples);

	return(1);
}

/////////////////////////////////////////////
int L::Initialization(int flag)
/////////////////////////////////////////////

{
	int    i, j;
	int    seed, InvolvedGene, SelectedPattern;
	double *magnitudes;

	if(flag == 3)
		Initialization();
	else
		Initialization(Afile0, Pfile0);

	// SeedA = RandomlizeMatrix(Amplitude, 'A');
	// SeedP = RandomlizeMatrix(Pattern, 'P');

	GetPriors();

	seed = SeedA0 + Npatterns + chain + 100;
	srand(seed);

	// calculate magnitudes of data rows
	// don't need now because of ScalingMock before updating  10/18/2005

	/*
	magnitudes = new double[Ngenes];

	for (i=0; i<Ngenes; i++) {
		magnitudes[i] = 0.;
		for (j=0; j<Nsamples; j++) magnitudes[i] += data[i][j];
		magnitudes[i] /= Nsamples;
	}
	*/

	for (i=0; i<Ngroups; i++) {
		// choose targeted pattern randomly
		// SelectedPattern = rand() % Npatterns;  // 0 ~ Npatterns
		SelectedPattern = i; // 0 ~ Npatterns

		for (j=0; j<Nmembers[i]; j++) {
			InvolvedGene = GroupPriors[i][j];  // make sure started at 0

			Amplitude[InvolvedGene * Npatterns + SelectedPattern] += weight;
			// printf("InvolvedGene %d SelectedPattern %d\n", InvolvedGene, SelectedPattern);
		}
	}

	// delete[] magnitudes;

	return(1);
}

/////////////////////////////////////////////////////
int L::CleanUpMemory()
/////////////////////////////////////////////////////
	
{
	int i;

	delete[] Amplitude;
	delete[] Pattern;
	delete[] A_Weights;
	delete[] P_Weights;
	delete[] ScannedA;
	delete[] ScannedP;
	delete[] normalizedP;
	delete[] Mock;

	if(ConnectivityCheck) 
	{
		delete[] connectivity;
		delete[] connectivity0;
	}

	return(1);
}

////////////////////////////////////////
int L::DoSimulation()
////////////////////////////////////////
	
{
	int    i, FakedChain;
	double Temperature;

	AllocateMemory();

	/*
	if(PriorFlag == 1)
		Initialization();
	else if(PriorFlag == 2)
		Initialization(Afile0, Pfile0);
	else if(PriorFlag >= 3)
		Initialization(PriorFlag);
	else

	{
		//printf("PriorFlag setting is not valid, should be 1~3\n");
		return(0);
	}
	*/

	Initialization();
	SA_simulation();
	CleanUpMemory();
	return(1);
}

///////////////////////////////////////////
int L::SA_simulation()
///////////////////////////////////////////
{
	int    i, j, k;
	int    CONN_Changed, Accumulated, FakedChain;
	double ErroValue;
	jstring outstr;
	char out[200];

	// StartCPU = clock();
	StartCPU = clock();
	time(&StartTimeInSecond);
	StartTime = string(ctime(&StartTimeInSecond));

	Accumulated = 0;

	FakedChain = chain * 1000;

	PrintMatrixes(Amplitude, Pattern, Npatterns, FakedChain,env,obj,BDout);

	sprintf(FileName, "%s%s_%d_%d.log", FilePathFromNodes, basename, Npatterns, chain);

	/*if( (LOG=fopen(FileName, "w")) == NULL) {
	  sprintf(out,"Could not open %s for writing!",FileName);
	  outstr = env->NewStringUTF(out);
	  env->CallVoidMethod(obj,meth,outstr);
	  //printf("Could not open %s for writing!\n", FileName);
	  return(-1);
	}*/
	
	// printf("chain %d uncertFlag = %d\n", chain, uncertFlag);
	ScaleData();
	// if( sparsityFlag ) Sparsiness();
	GenerateMock();
	// ScalingMock();
	GenerateWeights();

	Accumulated = 0;

	TestChiSquare();
	//fprintf(LOG, "round    0:  ChiSquare %15.8e rmsd %15.8e\n", ChiSquare, rmsd);

	for (i=0; i<SimulateIterations; i++) 
	{
		Updating(0);
		Accumulated ++;

		if(Accumulated == INTERM) 
		{
			Accumulated = 0;
			TestChiSquare();

			//fprintf(LOG, "round %4d:  ChiSquare %15.8e rmsd %15.8e\n", i, ChiSquare, rmsd);
		}

		UsedRound = i + 1;
	}

	TestChiSquare();
	Normalization();
	DeScaleData();

	//fclose(LOG);

	// EndCPU = clock();
	EndCPU = clock();
	time(&EndTimeInSecond);
	EndTime = string(ctime(&EndTimeInSecond));

	double UsedCPU = (double)(EndCPU - StartCPU) / (60.0 * (double)CLOCKS_PER_SEC);

	// FakedChain = chain * 100 + sample;
	FakedChain = chain;

	PrintMatrixes(Amplitude, Pattern, Npatterns, FakedChain,env,obj,BDout);
	//PrintInf(Amplitude, Pattern, Npatterns, FakedChain);
	PrintOutput(Mock, Npatterns, FakedChain, UsedRound, SeedA, SeedP,
	          rmsd, ChiSquare, StartTime, EndTime, UsedCPU,env,obj,BDout);
	outstr = env->NewStringUTF(FileName);
	meth = env->GetMethodID(cls,"writePattOut","(Ljava/lang/String;Lpattviewer/GenpatExp;)V");
	env->CallVoidMethod(obj,meth,outstr,BDout);
	meth = env->GetMethodID(cls,"guiPrint","(Ljava/lang/String;)V");

	return 1;
}

///////////////////////////////////////////
int L::SA_simulation(int sample)
///////////////////////////////////////////
{
	int    i, j;
	int    Nrounds, flag;

	GenerateMock();
	// ScalingMock();
	GenerateWeights();

	if(sample == 0) 
	{
		Nrounds = SimulateIterations;
		flag = 0;
	}
	else 
	{
		Nrounds = RelaxSteps;
		flag = 1;
	}

	for (i=0; i<Nrounds; i++) 
	{
		Updating(flag);
	}

	return 1;
}

///////////////////////////////////
int L::LiftingUncertainty(double scale)
///////////////////////////////////
	
{
	for (int i=0; i<Ngenes * Nsamples; i++) uncert[i] *= scale;
	return(1);
}

///////////////////////////////////
int L::RelaxingUncertainty(double scale)
///////////////////////////////////
	
{
	for (int i=0; i<Ngenes * Nsamples; i++) uncert[i] /= scale;
	return(1);
}

//////////////////////////////////////////////////////////////////////////////////
void L::TestChiSquare()
//////////////////////////////////////////////////////////////////////////////////
	
{
	int    i, j;
	double diff;

	ChiSquare = 0.0;
	rmsd = 0.0;
	for (i=0; i<Ngenes * Nsamples; i++)
	{
		diff = data[i] - Mock[i];
		diff = diff * diff;
		if(diff < eps) continue;

		ChiSquare += diff;

		if(uncertFlag && uncert[i] != 0.0) 
		{
			diff *= uncert[i] * uncert[i];
			rmsd += diff;
		}
	}

	if(uncertFlag == 0)
	{
		rmsd = ChiSquare;
	}
}

//////////////////////////////////////////////////////////////////////////////////
int L::TestConnectivity()
//////////////////////////////////////////////////////////////////////////////////
	
{
	int    i, j;
	int    diff, *Index;
	double max;

	Index = new int[Nsamples];

	for (i=0; i<Nsamples; i++)
	{
		max = -1.;
		Index[i] = -1;
		for (j=0; j<Npatterns; j++)
		{
			if(max < normalizedP[j * Nsamples + i])
			{
				max = normalizedP[j * Nsamples + i]; Index[i] = j;
			}
		}
	}

	for (i=0; i<Nsamples; i++)
	{
		for (j=i+1; j<Nsamples; j++) 
		{
			(Index[i] == Index[j]) ? connectivity[i * Nsamples + j] = 1 : connectivity[i * Nsamples + j] = 0;
		}
	}

	delete[] Index;

	diff = 0;
	for (i=0; i<Nsamples; i++)
	{
		for (j=i+1; j<Nsamples; j++) 

		{
			if(connectivity[i * Nsamples + j] != connectivity0[i * Nsamples + j]) diff ++;
			connectivity0[i * Nsamples + j] = connectivity[i * Nsamples + j];
		}
	}

	return diff;
}

////////////////////////////////////////////////////////////////////////////
int L::UpdateP(int I, int J)
////////////////////////////////////////////////////////////////////////////

{
	int    i, j, k;

	double oldValue = Pattern[I * Nsamples + J];

	if(Pattern[I * Nsamples + J] == 0.0) Pattern[I * Nsamples + J] = 1.0;
	Pattern[I * Nsamples + J] *= P_Weights[I * Nsamples + J];

	// Update specific element in Mock
	for (k=0; k<Ngenes; k++) 
	{
		double Changes = Amplitude[k * Npatterns + I] * (Pattern[I * Nsamples + J] - oldValue);

		if(uncertFlag) Changes /= uncert[k * Nsamples + J];
		Mock[k * Nsamples + J] += Changes;
	}

	// Update weight matrixes
	// Need further changes
	for (i=0; i<Npatterns; i++) 
	{
		double Changes = 0.0;
		for (k=0; k<Ngenes; k++)
		{
			Changes += Amplitude[k * Npatterns + i] * (Mock[k * Nsamples + J] - oldValue);
		}
		P_Weights[i * Nsamples + J] *= Changes;
	}

	return(1);
}

////////////////////////////////////////////////////////////////////////////
int L::UpdateA(int I, int J)
////////////////////////////////////////////////////////////////////////////

{
	int    i, j, k;

	return(1);
}

////////////////////////////////////////////////////////////////////////////
int L::Updating(int SamplingFlag)
////////////////////////////////////////////////////////////////////////////

{
	int    i, j, k;
	double scale;
	char   filename[100];

	FILE *TMP;

	// UPDATE P
	

	// updating element of P
	
	// sprintf(filename, "P.%d", round); 
	
	// TMP = fopen(filename, "w");
		
	if( SamplingFlag )
	{
		double ratio = (double) rand() / ((double) RAND_MAX + (double) 1);
		int SelectedEle = (int) (ratio * TotalSpace);
		// printf("SelectedEle %d\n", SelectedEle);

		if(SelectedEle < Aspace)
		{
			int I = SelectedEle / Npatterns;
			int J = SelectedEle - I * Npatterns;

			UpdateA(I, J);
			ScannedA[I * Npatterns + J] ++;
		}
		else
		{
			SelectedEle -= Aspace;

			int I = SelectedEle / Nsamples;
			int J = SelectedEle - I * Nsamples;

			UpdateP(I, J);
			ScannedP[I * Nsamples + J] ++;
		}

		return(1);
	}

	for (i=0; i<Npatterns*Nsamples; i++) 
	{
		// if(Pattern[i] < eps) Pattern[i] = 1.0;
		Pattern[i] *= P_Weights[i];
		// if(Pattern[i] < eps) Pattern[i] = eps;
	}

	// update Mock matrix based on updated P
	GenerateMock();
	GenerateWeights();

	for (i=0; i<Ngenes*Npatterns; i++) 
	{
		// if(Amplitude[i] < eps) Amplitude[i] = 1.0;
	       	Amplitude[i] *= A_Weights[i];
		// if(Amplitude[i] < eps) Amplitude[i] = eps;
	}

	// update Mock matrix based on updated P and A
	// if( sparsityFlag ) Sparsiness();
	GenerateMock();
	GenerateWeights();

	return(1);
}

//////////////////////////////////////////////////////////////
int L::RandomlizeMatrix(double *matrix, char id)
//////////////////////////////////////////////////////////////
	
{
	int   i, j;
	int   seed, Nrows, Ncolumns;

	// FILE *TMP;

	if(id == 'A') {
		Nrows = Ngenes; Ncolumns = Npatterns;
		// sprintf(FileName, "%s/%s_%d_%d.Aini", FilePathFromNodes, basename, Npatterns, chain);
		seed = SeedA0 + Npatterns + chain;
	} else {
		Nrows = Npatterns; Ncolumns = Nsamples;
		// sprintf(FileName, "%s/%s_%d_%d.Pini", FilePathFromNodes, basename, Npatterns, chain);
		seed = SeedP0 + Npatterns + chain;
	}

	// if((TMP=fopen(FileName, "w")) == NULL) return(-1);

	srand(seed);

	for (i=0; i<Nrows; i++)

	{
		for (j=0; j<Ncolumns; j++) 
		
		{
			matrix[i * Ncolumns + j] = (double)rand()/((double)(RAND_MAX)+(double)(1));
			// fprintf(TMP, " %5.3f", matrix[i][j]);
		}

		// fprintf(TMP, "\n");
	}

	// fclose(TMP);

	return(seed);
}

/////////////////////////////////////////
int L::GenerateWeights()
/////////////////////////////////////////

{
	int    i, j, k;

	for (i=0; i<Npatterns; i++) for (j=0; j<Nsamples; j++)
	{
		int EleIndex = i * Nsamples + j;
		double UP = 0.0;
		double LP = 0.0;
		for (k=0; k<Ngenes; k++)
		{
			int index1 = k * Npatterns + i;
			int index2 = k * Nsamples + j;

			if(Amplitude[index1] > eps)
			{
			       	if(data[index2] > eps) UP += Amplitude[index1] * data[index2];
				if(Mock[index2] > eps) LP += Amplitude[index1] * Mock[index2];
			}
		}

		if(LP < eps) 
		{
			// if(UP < eps) P_Weights[EleIndex] = 1.0; else P_Weights[EleIndex] = UP / eps;
			P_Weights[EleIndex] = 1.0;
		} 

		else

		{
			P_Weights[EleIndex] = UP / LP;
		}
	}

	for (i=0; i<Ngenes; i++) for (j=0; j<Npatterns; j++)
	{
		int EleIndex = i * Npatterns + j;
		double UA = 0.0;
		double LA = 0.0;
		for (k=0; k<Nsamples; k++)
		{
			int index1 = i * Nsamples + k;
			int index2 = j * Nsamples + k;

			if(Pattern[index1] > eps)
			{
				if(data[index1] > eps) UA += data[index1] * Pattern[index2];
				if(Mock[index1] > eps) LA += Mock[index1] * Pattern[index2];
			}
		}

		if(LA < eps) 
		{
			// if(UA < eps) A_Weights[EleIndex] = 1.0; else A_Weights[EleIndex] = UA / eps;
			A_Weights[EleIndex] = 1.0;
		}

		else

		{
			A_Weights[EleIndex] = UA / LA;
		}
	}

	return(1);
}

/////////////////////////////////////////
int L::ScaleData()
/////////////////////////////////////////
	
{
	if(! uncertFlag) return 0;

	for (int i=0; i<Ngenes*Nsamples; i++) data[i] /= uncert[i];

	return 1;
}
	

/////////////////////////////////////////
int L::DeScaleData()
/////////////////////////////////////////
	
{
	if(! uncertFlag) return 0;

	for (int i=0; i<Ngenes*Nsamples; i++) {
		data[i] *= uncert[i];
		Mock[i] *= uncert[i];
	}

	return 1;
}
	

/////////////////////////////////////////
int L::GenerateMock()
/////////////////////////////////////////

{
	int i, j, k;

	for (i=0; i<Ngenes; i++) 
	
	{
		for (j=0; j<Nsamples; j++)

		{
					
			Mock[i * Nsamples + j] = 0.;
			for (k=0; k<Npatterns; k++)
			{
				if(Amplitude[i * Npatterns + k] < eps || Pattern[k * Nsamples + j] < eps) continue;
				Mock[i * Nsamples + j] += Amplitude[i * Npatterns + k] * Pattern[k * Nsamples + j];
			}

			if(uncertFlag) Mock[i * Nsamples + j] /= uncert[i * Nsamples + j];
			// if(Mock[i * Nsamples + j] < eps) Mock[i * Nsamples + j] = eps;
		}
	}

	return(1);
}

////////////////////////////////////////////////////////////////
int L::NormalizeP()
////////////////////////////////////////////////////////////////
	
{
	int    i, j;
	double norm;

	for (i=0; i<Npatterns; i++)

	{
		norm = 0.;
		for (j=0; j<Nsamples; j++) norm += Pattern[i * Nsamples + j];
		for (j=0; j<Nsamples; j++) normalizedP[i * Nsamples + j] = Pattern[i * Nsamples + j]/norm;
	}

	return(1);
}

////////////////////////////////////////////////////////////////
int L::Sparsiness()
////////////////////////////////////////////////////////////////
	
{
	int    i, j, markindex;
	double cutoff, dmark, basis_vector[Npatterns];

	for (i=0; i<Ngenes; i++)

	{
		Zscoring(Amplitude, i, basis_vector, Npatterns);

		for (j=0; j<Npatterns; j++) {
			if(basis_vector[j] < Zcutoff) Amplitude[i * Npatterns + j] = 0.0;
		}

		// exit(0);
	}

	return(1);
}

///////////////////////////////////////////
int L::Normalization()
///////////////////////////////////////////
	
{
	int    i, j;
	double norm;

	for (i=0; i<Npatterns; i++)

	{
		norm = 0.;
		for (j=0; j<Nsamples; j++) norm += Pattern[i * Nsamples + j];

		for (j=0; j<Nsamples; j++) Pattern[i * Nsamples + j]  /= norm;
		for (j=0; j<Ngenes; j++) Amplitude[j * Npatterns + i] *= norm;
	}

	return(1);
}

