#ifndef _L_H_
#define _L_H_

#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <algorithm>
#include "io.h"
#include <jni.h>

using namespace std;

class L : public io

{
    public:
	int    Npatterns, chain, UsedRound;
	int    Aspace, TotalSpace;
	int    SeedA, SeedP;
	clock_t StartCPU, EndCPU;
	double *Mock, *Amplitude, *Pattern;
	int    *ScannedA, *ScannedP;
	double ChiSquare, rmsd;
	string StartTime, EndTime;
	time_t StartTimeInSecond, EndTimeInSecond;

	L(int npatterns,JNIEnv *e,jobject o,jobject b);
	L(JNIEnv *e, jobject o,jobject b);

	int    DoSimulation();
	int    SA_simulation(int sample);
	int    SA_simulation();

	~L();

    private:
	double *A_Weights, *P_Weights;
	double *normalizedP;
	int    *connectivity, *connectivity0;
	FILE   *LOG;

	int    Initialization();
	int    Initialization(int);
	int    Initialization(char *, char *);
	int    AllocateMemory();
	int    CleanUpMemory();
	int    RandomlizeMatrix(double *, char);
	int    GenerateWeights();
	int    GenerateMock();
	int    ScaleData();
	int    DeScaleData();
	int    ScalingMock();
	int    Sparsiness();
	int    NormalizeP();
	int    Normalization();
	int    Updating(int);
	int    UpdateA(int, int);
	int    UpdateP(int, int);
	int    TestConnectivity();
	int    LiftingUncertainty(double scale);
	int    RelaxingUncertainty(double scale);
	void   TestChiSquare();
	double diversity(double, double, double);
	double diversity(double, double);
};

#endif
