#include "io.h"

////////////////////////////////////
io::io()
////////////////////////////////////
	
{
}

////////////////////////////////////
io::io(char *path)
////////////////////////////////////
	
{
	strcpy(FilePathFromNodes, path);
}

////////////////////////////////////
io::~io()
////////////////////////////////////
	
{
}

/////////////////////////////////////////////////////////////////////
int io::GetParameters()
/////////////////////////////////////////////////////////////////////
	
{	
	FILE *DATA;

	sprintf(FileName, "%s%s.ctr", FilePathFromNodes, basename);

	if( (DATA=fopen(FileName,"r")) == NULL) {
		printf("Could not open control file %s!\n", FileName);
		return(-1);
	}

	sprintf(datafile, "%s%s.txt", FilePathFromNodes, basename);
	sprintf(uncertfile, "%s%s.unc", FilePathFromNodes, basename);

	printf("Working directory --- %s datafile --- %s\n", FilePathFromNodes, datafile);

	if(fscanf(DATA, "%d%d%d", &Ngenes, &Nsamples, &uncertFlag) == EOF) return(0);
	while(fgetc(DATA) != '\n') {}

	if(fscanf(DATA, "%d%d%d%d", &StartRank, &EndRank, &Nchains, &SimulateIterations) == EOF) return(0);
	while(fgetc(DATA) != '\n') {}

	fclose(DATA);

	return(1);
}


////////////////////////////////////////
void io::VerifyInputParams()
////////////////////////////////////////

{
  jstring outstr;
  char out[300];

  sprintf(out,"basename %s\ndatafile %s\n\nNgenes %d Nsamples %d Uncertainty flag %d\nTestedRanks %d-%d, Nchain %d, Total simulated rounds %d",basename,datafile,Ngenes,Nsamples,uncertFlag,StartRank,EndRank,Nchains,SimulateIterations);
  outstr = env->NewStringUTF(out);
  env->CallVoidMethod(obj,meth,outstr);
  //printf("basename %s\n", basename);
  //printf("datafile %s\n\n", datafile);
  //printf("Ngenes %d Nsamples %d Uncertainty flag %d\n", 
  //		Ngenes, Nsamples, uncertFlag);
  //printf("TestedRanks %d-%d, Nchain %d, Total simulated rounds %d\n", 
  //		StartRank, EndRank, Nchains, SimulateIterations);
}

/////////////////////////////////////////////////////////////////////
int io::GetPriors()
/////////////////////////////////////////////////////////////////////
	
{	
	int  i, j;
	char line[200];
	FILE *DATA;
	char out[200];
	jstring outstr;

	sprintf(FileName, "%s%s.link", FilePathFromNodes, basename);

	if( (DATA=fopen(FileName,"r")) == NULL) {
	  sprintf(out,"Could not open link file %s!",FileName);
	  outstr = env->NewStringUTF(out);
	  env->CallVoidMethod(obj,meth,outstr);
	  //printf("Could not open link file %s!\n", FileName);
	  return(-1);
	}

	fgets(line, 100, DATA);
	fgets(line, 100, DATA);
	fgets(line, 100, DATA);

	fscanf(DATA, "%d", &Ngroups);
	// printf("Ngroups %d\n", Ngroups);

	Nmembers = new int[Ngroups];
	GroupPriors = new int*[Ngroups];

	for (i=0; i<Ngroups; i++) {
	    fscanf(DATA, "%d", &Nmembers[i]);
	    GroupPriors[i] = new int[Nmembers[i]];
	}

	while(fgetc(DATA) != '\n') {}

	for (i=0; i<Ngroups; i++) {
	    for (j=0; j<Nmembers[i]; j++) {
		fscanf(DATA, "%d", &GroupPriors[i][j]);
		while(fgetc(DATA) != '\n') {}

	    }
	}

	fclose(DATA);

	return(1);
}

////////////////////////////////////////////////////////////////////////////////////////////////
int io::ProcessingInput(int argv, char **argu)
////////////////////////////////////////////////////////////////////////////////////////////////

{
	strcpy(basename,argu[1]);

	return(1);
}

///////////////////////////////////////
int io::ReadSourceData()
///////////////////////////////////////
	
{
	int    i, j;

	data = new double[Ngenes * Nsamples];

	if(uncertFlag) 
	{
		uncert = new double[Ngenes * Nsamples];
		if(ReadDoubleInput() <= 0) return(-1);
	} 
	
	else

	{
		if(ReadSingleInput() <= 0) return(-1);
	}

	return(1);
}

////////////////////////////////////////////////////////////////////////////////
int io::ReadMatrix(double *matrix, char *filename, int Nrows, int Ncolumns)
////////////////////////////////////////////////////////////////////////////////
	
{
	int    i, j;
	jstring outstr;
	char out[200];
	
	FILE *MATRIX;

	if((MATRIX = fopen(filename,"r")) == NULL) {
	  sprintf(out,"Could not open %s",filename);
	  outstr = env->NewStringUTF(out);
	  env->CallVoidMethod(obj,meth,outstr);
	  //printf("Could not open %s\n", filename);
	  exit(-1);
	}

	for (i=0; i<Nrows; i++)
		for (j=0; j<Ncolumns; j++)
			fscanf(MATRIX, "%lf", &matrix[i * Ncolumns + j]);

	fclose(MATRIX);

	return(1);
}

/////////////////////////////////////////////////////////////////////
int io::ReadDoubleInput()
/////////////////////////////////////////////////////////////////////
	
{	
	int  i, j;
	char **genes1, **expts1, **genes2, **expts2;
	FILE *DATA, *UNCERT;

	if( (DATA=fopen(datafile,"r")) == NULL) {
		printf("Could not open data file %s!\n", datafile);
		return(-1);
	}

	genes1 = new char*[Ngenes];
	for (i=0; i<Ngenes; i++) genes1[i] = new char[NAMEL];
	expts1 = new char*[Nsamples];
	for (i=0; i<Nsamples; i++) expts1[i] = new char[NAMEL];
	
	for (i=0; i<Nsamples; i++) fscanf(DATA, "%s", expts1[i]);
	while(fgetc(DATA) != '\n') {}

	int Observed = 0;
	for (i=0; i<Ngenes; i++)
	{
	    	if(fscanf(DATA, "%s", genes1[i]) != EOF) 
	    	{
			for (j=0; j<Nsamples; j++)
			{
				fscanf(DATA, "\t%lf", &data[i * Nsamples + j]);
				if(data[i * Nsamples + j] < 0) data[i * Nsamples + j] = 0.0;
			}

			while(fgetc(DATA) != '\n') {}

			Observed ++;
	    	}

		else

		{
			break;
		}
	}

	fclose(DATA);

	if(Observed < Ngenes)
	{ 
		printf("data in file is not fitting to Ngenes(%d) and Nsamples(%d), the last row is %d\n",
			Ngenes, Nsamples, Observed);
		return 0;
	}

	if( (UNCERT=fopen(uncertfile,"r")) == NULL) {
		printf("Could not open data file %s!\n", uncertfile);
		return -1;
	}

	genes2 = new char*[Ngenes];
	for (i=0; i<Ngenes; i++) genes2[i] = new char[NAMEL];
	expts2 = new char*[Nsamples];
	for (i=0; i<Nsamples; i++) expts2[i] = new char[NAMEL];
	
	for (i=0; i<Nsamples; i++) fscanf(UNCERT, "%s", expts2[i]);
	while(fgetc(UNCERT) != '\n') {}

	Observed = 0;
	for (i=0; i<Ngenes; i++)
	{
	    	if(fscanf(UNCERT, "%s", genes2[i]) != EOF) 
	    	{
			for (j=0; j<Nsamples; j++)
			{
				fscanf(UNCERT, "\t%lf", &uncert[i * Nsamples + j]);
				if(data[i * Nsamples + j] <= 0) uncert[i * Nsamples + j] = 1.0;
			}

			while(fgetc(UNCERT) != '\n') {}

			Observed ++;
	    	}

		else

		{
			break;
		}
	}

	fclose(UNCERT);

	/*
	for (i=0; i<Ngenes; i++) printf(" %s", genes1[i]);
	printf("\n");
	for (i=0; i<Nsamples; i++) printf(" %s", expts1[i]);
	printf("\n");
	*/

	for (i=0; i<Ngenes; i++) delete []genes1[i];
	delete []genes1;
	for (i=0; i<Nsamples; i++) delete []expts1[i];
	delete []expts1;
	
	for (i=0; i<Ngenes; i++) delete []genes2[i];
	delete []genes2;
	for (i=0; i<Nsamples; i++) delete []expts2[i];
	delete []expts2;
	
	if(Observed < Ngenes)
	{ 
		printf("uncertainty in file is not fitting to Ngenes(%d) and Nsamples(%d), the last row is %d\n",
			Ngenes, Nsamples, Observed);
		return -1;
	}
	return(1);
}

/////////////////////////////////////////////////////////////////////
int io::ReadSingleInput()
/////////////////////////////////////////////////////////////////////
	
{	
	int  i, j;
	char **genes, **expts;
	FILE *DATA;

	if( (DATA=fopen(datafile,"r")) == NULL) {
		printf("Could not open data file %s!\n", datafile);
		return(-1);
	}

	genes = new char*[Ngenes];
	for (i=0; i<Ngenes; i++) genes[i] = new char[NAMEL];
	expts = new char*[Nsamples];
	for (i=0; i<Nsamples; i++) expts[i] = new char[NAMEL];
	
	for (i=0; i<Nsamples; i++) fscanf(DATA, "\t%s", expts[i]);
	while(fgetc(DATA) != '\n') {}

	int Observed = 0;
	for (i=0; i<Ngenes; i++)
	{
	    	if(fscanf(DATA, "%s", genes[i]) != EOF) 
	    	{
			for (j=0; j<Nsamples; j++)
			{
				fscanf(DATA, "\t%lf", &data[i * Nsamples + j]);
				if(data[i * Nsamples + j] < 0) data[i * Nsamples + j] = 0.0;
			}

			while(fgetc(DATA) != '\n') {}

			Observed ++;
	    	}

		else

		{
			break;
		}
	}

	fclose(DATA);

	for (i=0; i<Ngenes; i++) delete []genes[i];
	delete []genes;
	for (i=0; i<Nsamples; i++) delete []expts[i];
	delete []expts;
	
	if(Observed < Ngenes)
	{ 
		printf("data in file is not fitting to Ngenes(%d) and Nsamples(%d), the last row is %d\n",
			Ngenes, Nsamples, Observed);
		return -1;
	}

	return(1);
}

/////////////////////////////////////////////////////////////////////////////////////
int io::PrintMatrixes(double *A,double *P,int Npatterns,int chain,JNIEnv* env,jobject obj,jobject BDout)
/////////////////////////////////////////////////////////////////////////////////////
	
{
	int  i, j;
	//FILE *MATRIX;
	jstring outstr;
	char out[200];
	string RecordTimeString;
	time_t RecordTimeInSeond;
	jfieldID fid;
	jclass cls2;
	jdoubleArray dArray;
	jobjectArray oArray;
	jobjectArray oArray2;
	double *footprint, *mean, *sdev;

	time(&RecordTimeInSeond);
	RecordTimeString = string(ctime(&RecordTimeInSeond));

	cls2 = env->GetObjectClass(BDout);

	fid = env->GetFieldID(cls2,"Na","I");
	env->SetIntField(BDout,fid,Ngenes);
	fid = env->GetFieldID(cls2,"Nf","I");
	env->SetIntField(BDout,fid,Nsamples);
	fid = env->GetFieldID(cls2,"Nsol","I");
	env->SetIntField(BDout,fid,Npatterns);

	fid = env->GetFieldID(cls2,"date","Ljava/lang/String;");
	RecordTimeString[24]='\0';
	outstr = env->NewStringUTF(RecordTimeString.c_str());
	env->SetObjectField(BDout,fid,outstr);

	fid = env->GetFieldID(cls2,"Nfoot","I");
	env->SetIntField(BDout,fid,1);
	fid = env->GetFieldID(cls2,"footprint","[D");
	footprint = new double[1];
	footprint[0]=1.0;
	dArray = env->NewDoubleArray(1);
	env->SetDoubleArrayRegion(dArray,0,1,footprint);
	env->SetObjectField(BDout,fid,dArray);

	// Amplitude matrix
	sprintf(FileName, "%s%s_%d_%d_A.dat", FilePathFromNodes, basename, Npatterns, chain);

	//outstr = env->NewStringUTF(FileName);
	//env->CallVoidMethod(obj,meth,outstr);


	  /*if( (MATRIX=fopen(FileName, "w")) == NULL ) {
	  sprintf(out,"Could not open %s for writing!",FileName);
	  outstr = env->NewStringUTF(out);
	  env->CallVoidMethod(obj,meth,outstr);
	  //printf("Could not open %s for writing!\n", FileName);
	  return(-1);
	  }*/

	dArray = env->NewDoubleArray(Npatterns);
	oArray = env->NewObjectArray(Ngenes,env->GetObjectClass(dArray),dArray);
	oArray2 = env->NewObjectArray(Ngenes,env->GetObjectClass(dArray),dArray);
	for (i=0; i<Ngenes; i++){
	  mean = new double[Npatterns];
	  sdev = new double[Npatterns];
	  for (j=0; j<Npatterns; j++){
	    mean[j]=A[i*Npatterns+j];
	    sdev[j]=0;
	    //fprintf(MATRIX, " %8.5e", A[i * Npatterns + j]);
	  }
	  //fprintf(MATRIX, "\n");
	  dArray = env->NewDoubleArray(Npatterns);
	  env->SetDoubleArrayRegion(dArray,0,Npatterns,mean);
	  env->SetObjectArrayElement(oArray,i,dArray);
	  dArray = env->NewDoubleArray(Npatterns);
	  env->SetDoubleArrayRegion(dArray,0,Npatterns,sdev);
	  env->SetObjectArrayElement(oArray2,i,dArray);
	}
	fid = env->GetFieldID(cls2,"distribution","[[D");
	env->SetObjectField(BDout,fid,oArray);
	fid = env->GetFieldID(cls2,"distSD","[[D");
	env->SetObjectField(BDout,fid,oArray2);

	//fclose(MATRIX);

	// Pattern matrix
	sprintf(FileName, "%s%s_%d_%d_P.dat", FilePathFromNodes, basename, Npatterns, chain);

	/*if( (MATRIX=fopen(FileName, "w")) == NULL ) {
	  sprintf(out,"Could not open %s for writing!",FileName);
	  outstr = env->NewStringUTF(out);
	  env->CallVoidMethod(obj,meth,outstr);
	  //printf("Could not open %s for writing!\n", FileName);
	  return(-1);
	  }*/

	dArray = env->NewDoubleArray(Nsamples);
	oArray = env->NewObjectArray(Npatterns,env->GetObjectClass(dArray),dArray);
	oArray2 = env->NewObjectArray(Npatterns,env->GetObjectClass(dArray),dArray);
	for (i=0; i<Npatterns; i++){
	  mean = new double[Nsamples];
	  sdev = new double[Nsamples];
	  for (j=0; j<Nsamples; j++){
	    mean[j]=P[i*Nsamples+j];
	    sdev[j]=0;
	    //fprintf(MATRIX, " %8.5e", P[i * Nsamples + j]);
	  }
	  //fprintf(MATRIX, "\n");
	  dArray = env->NewDoubleArray(Nsamples);
	  env->SetDoubleArrayRegion(dArray,0,Nsamples,mean);
	  env->SetObjectArrayElement(oArray,i,dArray);
	  dArray = env->NewDoubleArray(Nsamples);
	  env->SetDoubleArrayRegion(dArray,0,Nsamples,sdev);
	  env->SetObjectArrayElement(oArray2,i,dArray);
	}
	fid = env->GetFieldID(cls2,"pattern","[[D");
	env->SetObjectField(BDout,fid,oArray);
	fid = env->GetFieldID(cls2,"pattSD","[[D");
	env->SetObjectField(BDout,fid,oArray2);

	//fclose(MATRIX);

	return(1);
}
	
/////////////////////////////////////////////////////////////////////////////////////
int io::PrintInf(double *A, double *P, int Npatterns, int chain)
/////////////////////////////////////////////////////////////////////////////////////

{
	int    i, j;
	double **Z, **P1;
	string RecordTimeString;
	time_t RecordTimeInSeond;

	FILE   *INF;

	double natE = exp(1.0);
	jstring outstr;
	char out[200];

	time(&RecordTimeInSeond);
	RecordTimeString = string(ctime(&RecordTimeInSeond));

	// BD inf format file
	sprintf(FileName, "%s%s_%d_%d.inf", FilePathFromNodes, basename, Npatterns, chain);

	if( (INF=fopen(FileName, "w")) == NULL) {
	  sprintf(out,"Could not open %s for writing!",FileName);
	  outstr = env->NewStringUTF(out);
	  env->CallVoidMethod(obj,meth,outstr);
	  //printf("Could not open %s for writing!\n", FileName);
	  return(-1);
	}

	fprintf(INF, "%s\n", basename);

	fprintf(INF, "%d %d %d\n", Npatterns, Ngenes, Nsamples);

	fprintf(INF, "%s", RecordTimeString.c_str());

	fprintf(INF, "1\n1.000000e+00\n");
	
	Z = new double*[Ngenes];
	for (i=0; i<Ngenes; i++) Z[i] = new double[Npatterns];

	// Scaling A based on row
	for (i=0; i<Ngenes; i++) Zscoring(A, i, Z[i], Npatterns);

	for (j=0; j<Npatterns; j++)
		for (i=0; i<Ngenes; i++)
			fprintf(INF, "    %15.5e %lf\n", exp(Z[i][j]), natE);

	for (i=0; i<Ngenes; i++) delete []Z[i];
	delete []Z;

	// Scaling P based on column, first transpose P
	P1 = new double*[Nsamples];
	for (i=0; i<Nsamples; i++) P1[i] = new double[Npatterns];

	Z = new double*[Nsamples];
	for (i=0; i<Nsamples; i++) Z[i] = new double[Npatterns];

	for (i=0; i<Npatterns; i++)
		for (j=0; j<Nsamples; j++)
			P1[j][i] = P[i * Nsamples + j];

	for (i=0; i<Nsamples; i++) Zscoring(P1[i], Z[i], Npatterns);

	for (j=0; j<Npatterns; j++)
		for (i=0; i<Nsamples; i++)
			fprintf(INF, "    %15.5e %lf\n", exp(Z[i][j]), natE);

	for (i=0; i<Nsamples; i++) { delete []P1[i]; delete []Z[i]; }
	delete []P1; delete []Z;

	fclose(INF);

	return(1);
}

/////////////////////////////////////////////////////////////////////////////////////
int io::PrintOutput(double *Mock, int Npatterns, int chain, int UsedRound,
		    long SeedA, long SeedP, double rmsd, double ChiSquare,
		    string StartTime, string EndTime, double UsedMins,
		    JNIEnv *env, jobject obj, jobject BDout)
/////////////////////////////////////////////////////////////////////////////////////
	
{
	int    i, j;
	double diff;

	//FILE *OUT;
	jstring outstr;
	char out[200];
	jclass cls2;
	jfieldID fid;
	jstring tag;
	jdoubleArray dArray;
	jobjectArray oArray;

	// BD out format file
	sprintf(FileName, "%srun%d_chain%d/%s_%d_%d.gpe", FilePathFromNodes,Npatterns,chain, basename, Npatterns, chain);

	/*if( (OUT=fopen(FileName, "w")) == NULL) {
	  sprintf(out,"Could not open %s for writing!",FileName);
	  outstr = env->NewStringUTF(out);
	  env->CallVoidMethod(obj,meth,outstr);
	  //printf("Could not open %s for writing!\n", FileName);
	  return(-1);
	  }*/

	cls2 = env->GetObjectClass(BDout);

	//fprintf(OUT, "%s\n", basename);
	tag = env->NewStringUTF(basename);
	fid = env->GetFieldID(cls2,"tag","Ljava/lang/String;");
	env->SetObjectField(BDout,fid,tag);

	//fprintf(OUT, "%15.8e %15.8e 0.0 0.0\n", ChiSquare, rmsd);
	fid = env->GetFieldID(cls2,"chisq","D");
	env->SetDoubleField(BDout,fid,ChiSquare);
	fid = env->GetFieldID(cls2,"AtomsA","D");
	env->SetDoubleField(BDout,fid,rmsd);
	fid = env->GetFieldID(cls2,"AtomsF","D");
	env->SetDoubleField(BDout,fid,0.0);
	fid = env->GetFieldID(cls2,"Evidence","D");
	env->SetDoubleField(BDout,fid,0.0);

	//fprintf(OUT, "1 %d %d %d %d\n", SimulateIterations, UsedRound, SeedA, SeedP);
	fid = env->GetFieldID(cls2,"ENSEMBLE","I");
	env->SetIntField(BDout,fid,1);
	fid = env->GetFieldID(cls2,"Niter","I");
	env->SetIntField(BDout,fid,SimulateIterations);
	fid = env->GetFieldID(cls2,"Nshow","I");
	env->SetIntField(BDout,fid,UsedRound);
	fid = env->GetFieldID(cls2,"Iseed","I");
	env->SetIntField(BDout,fid,SeedA);
	fid = env->GetFieldID(cls2,"SeedP","I");
	env->SetIntField(BDout,fid,SeedP);

	//fprintf(OUT, "%d %d %d\n", Npatterns, Ngenes, Nsamples);
	fid = env->GetFieldID(cls2,"Nsol","I");
	env->SetIntField(BDout,fid,Npatterns);
	fid = env->GetFieldID(cls2,"Na","I");
	env->SetIntField(BDout,fid,Ngenes);
	fid = env->GetFieldID(cls2,"Nf","I");
	env->SetIntField(BDout,fid,Nsamples);

	//fprintf(OUT, "0.000000e+00   1.000000e+00\n");
	//fprintf(OUT, "0.000000e+00   1.000000e+00   %d\n", Nsamples);
	fid = env->GetFieldID(cls2,"lineMeasure","D");
	env->SetDoubleField(BDout,fid,0.0);
	fid = env->GetFieldID(cls2,"ptwidth","D");
	env->SetDoubleField(BDout,fid,1.0);

	/*for (i=0; i<Ngenes * Nsamples; i++)

	{
		diff = fabs(data[i] - Mock[i]);

		if(uncertFlag) {
			if(diff <= 1.0)
				fprintf(OUT, "   %10.4f %10.4f %10.4f\n", data[i], Mock[i], uncert[i]);
			else
				fprintf(OUT, "   %10.4f %10.4f %10.4f *\n", data[i], Mock[i], uncert[i]);
		} else {
			fprintf(OUT, "   %10.4f %10.4f\n", data[i], Mock[i]);
		}
		}*/

	dArray = env->NewDoubleArray(Nsamples);
	oArray = env->NewObjectArray(Ngenes,env->GetObjectClass(dArray),dArray);
	for(i=0;i<Ngenes;i++){
	  dArray = env->NewDoubleArray(Nsamples);
	  env->SetDoubleArrayRegion(dArray,0,Nsamples,&(data[i*Nsamples]));
	  env->SetObjectArrayElement(oArray,i,dArray);
	}
	fid = env->GetFieldID(cls2,"data","[[D");
	env->SetObjectField(BDout,fid,oArray);

	dArray = env->NewDoubleArray(Nsamples);
	oArray = env->NewObjectArray(Ngenes,env->GetObjectClass(dArray),dArray);
	for(i=0;i<Ngenes;i++){
	  dArray = env->NewDoubleArray(Nsamples);
	  env->SetDoubleArrayRegion(dArray,0,Nsamples,&(Mock[i*Nsamples]));
	  env->SetObjectArrayElement(oArray,i,dArray);
	}
	fid = env->GetFieldID(cls2,"mock","[[D");
	env->SetObjectField(BDout,fid,oArray);

	dArray = env->NewDoubleArray(Nsamples);
	oArray = env->NewObjectArray(Ngenes,env->GetObjectClass(dArray),dArray);
	for(i=0;i<Ngenes;i++){
	  dArray = env->NewDoubleArray(Nsamples);
	  env->SetDoubleArrayRegion(dArray,0,Nsamples,&(uncert[i*Nsamples]));
	  env->SetObjectArrayElement(oArray,i,dArray);
	}
	fid = env->GetFieldID(cls2,"noise","[[D");
	env->SetObjectField(BDout,fid,oArray);

	/*fprintf(OUT, "\nSimulation is completed after %d round\n", UsedRound);
	fprintf(OUT, "Final Chi-square deviation: %15.8e\n", ChiSquare);
	fprintf(OUT, "Final RMSD        deviation: %15.8e\n", rmsd);

	fprintf(OUT, "\n/// Started at: %s", StartTime.c_str());
	fprintf(OUT, "/// Ended   at: %s", EndTime.c_str());
	fprintf(OUT, "/// Used CPU:  %g minutes\n", UsedMins);

	fclose(OUT);*/
	
	return(1);
}
