#ifndef IO_H_
#define IO_H_

#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "Common.h"
#include <jni.h>

using std::string;

class io : public Common

{
    public:
	int    Ngenes, Nsamples, uncertFlag;
	int    StartRank, EndRank, Nchains, SimulateIterations;
	int    Ngroups, *Nmembers, **GroupPriors;
	int    ConnectivityCheck, PriorFlag, sparsityFlag;
	int    SA_STEP, RelaxSteps, Nstartpoints;
	double StartTMPT, Zcutoff;
	double *data, *uncert;
	double sparsityscale;
	char   basename[NAMEL], datafile[NAMEL], ctrlfile[NAMEL], uncertfile[NAMEL];
	char   FileName[NAMEL];
	char   FilePathFromNodes[NAMEL];
	char   Afile0[NAMEL], Pfile0[NAMEL];
	JNIEnv *env;
	jobject obj;
	jclass cls;
	jmethodID meth;
	jobject BDout;

	io();
	io(char *);
	~io();

	int    GetParameters();
	int    GetPriors();
	int    ProcessingInput(int, char **);
	int    ReadSourceData();
	int    ReadMatrix(double *, char *, int, int);
	void   VerifyInputParams();
	int    PrintMatrixes(double *, double *, int, int, JNIEnv *, jobject, jobject);
	int    PrintInf(double *, double *, int, int);
	int    PrintOutput(double *, int, int, int, long, long, double, double, string, string, double,JNIEnv *,jobject,jobject);

    private:
	int    ReadDoubleInput();
	int    ReadSingleInput();

};

#endif
