#include <unistd.h>
#include <time.h>
#include "Common.h"
#include "io.h"
#include "L.h"
#include <string>
#include <jni.h>
#include "lib_LSNMF.h"

int main(){
  return 0;
}

     JNIEXPORT jint JNICALL Java_lib_LSNMF_lsnmf(JNIEnv* env, jobject obj, jobject BDin, jobject BDout){
       jclass cls;
       jmethodID meth;
       jfieldID fid;
       jstring outstr;
       char out[200];

       const  char *str;
       jstring tag;
       jstring dir;
       jint Na;
       jint Nf;
       jdoubleArray data;
       jdoubleArray acc;

       jint uncertFlag;
       jint StartRank;
       jint EndRank;
       jint Nchains;
       jint Niter;

       jint NfeetA;
       jintArray NfootA;
       jobjectArray twoDarray;
       jintArray* NlistA;

       jobjectArray geneNames;
       jobjectArray xLabels;

       int    i, j, k;
       int    myRank, flag;
       clock_t StartCPU, EndCPU;
       time_t StartTimeInSecond, EndTimeInSecond;
       double longest_run_time;
       char   workingpath[NAMEL];
       string StartTime, EndTime;
       string nodepath;
       L *myNMF;
       
       StartCPU = clock();
       time(&StartTimeInSecond);
       StartTime = string(ctime(&StartTimeInSecond));

       cls = env->GetObjectClass(obj);
       meth = env->GetMethodID(cls,"guiPrint","(Ljava/lang/String;)V");
       sprintf(out,"Running LSNMF");
       outstr = env->NewStringUTF(out);
       env->CallVoidMethod(obj,meth,outstr);
       
       cls = env->GetObjectClass(BDin);
       myNMF = new L(env,obj,BDout);

       fid = env->GetFieldID(cls,"tag","Ljava/lang/String;");
       tag = (jstring)env->GetObjectField(BDin,fid);
       str = env->GetStringUTFChars(tag,0);
       strcpy(myNMF->basename,str);

       fid = env->GetFieldID(cls,"dir","Ljava/lang/String;");
       dir = (jstring)env->GetObjectField(BDin,fid);
       str = env->GetStringUTFChars(dir,0);
       strcpy(myNMF->FilePathFromNodes,str);
       sprintf(myNMF->datafile,"%s%s.txt",myNMF->FilePathFromNodes,myNMF->basename);
       sprintf(myNMF->uncertfile,"%s%s.unc",myNMF->FilePathFromNodes,myNMF->basename);

       fid = env->GetFieldID(cls,"Na","I");
       Na = env->GetIntField(BDin,fid);
       myNMF->Ngenes = Na;

       fid = env->GetFieldID(cls,"Nf","I");
       Nf = env->GetIntField(BDin,fid);
       myNMF->Nsamples = Nf;

       fid = env->GetFieldID(cls,"data","[D");
       data = (jdoubleArray)env->GetObjectField(BDin,fid);
       myNMF->data = env->GetDoubleArrayElements(data,0);

       fid = env->GetFieldID(cls,"acc","[D");
       acc = (jdoubleArray)env->GetObjectField(BDin,fid);
       myNMF->uncert = env->GetDoubleArrayElements(acc,0);

       fid = env->GetFieldID(cls,"uncertFlag","I");
       uncertFlag = env->GetIntField(BDin,fid);
       myNMF->uncertFlag = uncertFlag;

       fid = env->GetFieldID(cls,"StartRank","I");
       StartRank = env->GetIntField(BDin,fid);
       myNMF->StartRank = StartRank;

       fid = env->GetFieldID(cls,"EndRank","I");
       EndRank = env->GetIntField(BDin,fid);
       myNMF->EndRank = EndRank;

       fid = env->GetFieldID(cls,"Nchains","I");
       Nchains = env->GetIntField(BDin,fid);
       myNMF->Nchains = Nchains;

       fid = env->GetFieldID(cls,"Niter","I");
       Niter = env->GetIntField(BDin,fid);
       myNMF->SimulateIterations = Niter;

       fid = env->GetFieldID(cls,"NfeetA","I");
       NfeetA = env->GetIntField(BDin,fid);
       myNMF->Ngroups = NfeetA;

       fid = env->GetFieldID(cls,"NfootA","[I");
       NfootA = (jintArray)env->GetObjectField(BDin,fid);
       myNMF->Nmembers = (int*)env->GetIntArrayElements(NfootA,0);

       fid = env->GetFieldID(cls,"NlistA","[[I");
       twoDarray = (jobjectArray)env->GetObjectField(BDin,fid);
       myNMF->GroupPriors = new int*[NfeetA];
       NlistA = new jintArray[NfeetA];
       for(i=0;i<NfeetA;i++){
	 myNMF->GroupPriors[i] = new int[myNMF->Nmembers[i]];
	 NlistA[i] = (jintArray)env->GetObjectArrayElement(twoDarray,i);
	 for(j=0;j<myNMF->Nmembers[i];j++){
	   myNMF->GroupPriors[i][j] = ((int*)env->GetIntArrayElements(NlistA[i],0))[j];
	 }
       }

       fid = env->GetFieldID(cls,"geneNames","[Ljava/lang/String;");
       geneNames = (jobjectArray)(env->GetObjectField(BDin,fid));
       fid = env->GetFieldID(cls,"xLabels","[Ljava/lang/String;");
       xLabels = (jobjectArray)(env->GetObjectField(BDin,fid));

       cls = env->GetObjectClass(BDout);
       fid = env->GetFieldID(cls,"geneNames","[Ljava/lang/String;");
       env->SetObjectField(BDout,fid,geneNames);
       fid = env->GetFieldID(cls,"xLabels","[Ljava/lang/String;");
       env->SetObjectField(BDout,fid,xLabels);

       //myNMF->GetParameters();
	// printf("\nBasename --->  %s\n\n", myNMF->basename);
	myNMF->VerifyInputParams();
	//if(myNMF->ReadSourceData() < 0) exit(0);

	// Do simulations
	for (int npatterns=myNMF->StartRank; npatterns<=myNMF->EndRank; npatterns++) {
		for(int chain=1; chain<=myNMF->Nchains; chain++) {
			myNMF->Npatterns = npatterns;
			myNMF->chain = chain;
			cls = env->GetObjectClass(obj);
			meth = env->GetMethodID(cls,"guiPrint","(Ljava/lang/String;)V");
			sprintf(out,"Npatterns %d chain %d",myNMF->Npatterns,myNMF->chain);
			outstr = env->NewStringUTF(out);
			env->CallVoidMethod(obj,meth,outstr);
			//printf("Npatterns %d chain %d\n", myNMF->Npatterns, myNMF->chain);
			flag = myNMF->DoSimulation();
		}
	}

   	time(&EndTimeInSecond);
   	EndTime = string(ctime(&EndTimeInSecond));

       cls = env->GetObjectClass(obj);
       meth = env->GetMethodID(cls,"guiPrint","(Ljava/lang/String;)V");
       sprintf(out,"//// Start at:   %s\n//// End   at:    %s",StartTime.c_str(),EndTime.c_str());
       outstr = env->NewStringUTF(out);
       env->CallVoidMethod(obj,meth,outstr);

       //printf("//// Start at:    %s",StartTime.c_str());
       //printf("//// End   at:    %s",EndTime.c_str());

       EndCPU = clock();
       sprintf(out,"//// Used CPU:  %g minutes\n",(double)(EndCPU-StartCPU)/(60.*(double)CLOCKS_PER_SEC));
       outstr = env->NewStringUTF(out);
       env->CallVoidMethod(obj,meth,outstr);
       //printf("//// Used CPU:  %g minutes\n", (double)(EndCPU - StartCPU) / (60.*(double)CLOCKS_PER_SEC));

	delete myNMF;

   	return 0;
}
