// Class: PattI
//
// Purpose: Interface implemented by PattS for running PattRun with RMI
//
// History: v1.0 8/03 WFS
//          v1.1 5/06 WFS
//
// COPYRIGHT, 2003, Fox Chase Cancer Center
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Gerneral Public License
// as published by the Free Software Foundation; either version 2
// of the license, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// NERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General public License for more details.
//
// You should have recieved a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

package rmi;

import java.rmi.*;
import javax.swing.JTextPane;
import java.util.Properties;

import pattviewer.*;
import lib.*;

public interface PattI extends Remote {
    public static int version = 200601;
    public static String copyright = "Copyright 2006, Fox Chase Cancer Center";

    public void guiPrint(String output)throws Exception;

    public void writePattOut(String filename, GenpatExp pattOut)throws RemoteException;

    public void run(int whichC, PattInput pattIn, int p)throws RemoteException;

    public boolean isBusy()throws RemoteException;

    public Library[] getLibraries() throws RemoteException;

    public String[] getStatus() throws RemoteException;
}
