// Class: ImageFilter
//
// Purpose: filters the displayed files in a filechooser to only show certain extensions
//
// History v1.0 6/03 WFS
//
// COPYRIGHT, 2003, Fox Chase Cancer Center
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the license, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have recieved a copy of the GNU General Public License
// along with this program;  if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA   02111-1307, USA.

package textfields;

import java.io.File;
import java.util.LinkedList;

public class ImageFilter extends javax.swing.filechooser.FileFilter{
    private LinkedList<String> extensions;
    public ImageFilter(String ext){
	extensions=new LinkedList<String>();
        extensions.add(ext);
    }
    public ImageFilter(LinkedList<String> ext){
	extensions=ext;
    }
    public void addExt(String ext){
        extensions.add(ext);
    }
    private static String getExtension(File f){
	String ext=null;
	String s=f.getName();
	int in=s.lastIndexOf('.');
	if(in>0&&in<s.length()-1){
	    ext=s.substring(in+1).toLowerCase();
	}
	return ext;
    }

    public boolean accept(File f){
	if(f.isDirectory()){
	    return true;
	}

	String ext=getExtension(f);
	if(ext != null)
	    if(extensions.contains(ext))
		return true;
	return false;
    }
    public String getDescription(){
        String temp="";
        for(int i=0;i<extensions.size()-1;i++){
            temp+=(String)extensions.get(i)+", ";
        }
        temp+=(String)extensions.getLast()+" files (";
        for(int i=0;i<extensions.size()-1;i++){
            temp+="*."+(String)extensions.get(i)+", ";
        }
        temp+="*."+(String)extensions.getLast()+")";
        return temp;
//	return extension+" files (*."+extension+")";
    }
}
