// Class: PattImage
//
// Purpose: Imports Bayesian Decomposition data, creates two-dimensional graphs, and exports data
//
// History: v0.6 5/02 William F Speier IV
//
// COPYRIGHT, 2002, Fox Chase Cancer Center
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the license, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have recieved a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

package viewer;

import javax.swing.JOptionPane;

public class PattImage extends PattFrame {
    public static int version = 200201;
    public static String copyright = "Copyright 2002, Fox Chase Cancer Center";

    public PattImage() {
      super();
    }    
    
    public static void main(String argv[]) {
	PattImage pattview = new PattImage();
	pattview.setVisible(true);
    }

/*
* if distribution is selected, it will create a bitmap object through ImageCanvas 
* otherwise, it will call makegraph() through PattFrame
*/    
    protected void makeGraph(){
	try{
	    if(dataLabels[0]==4&&!isBV){
	        ic.setDisplayZeroFlag(false);
	        label.setText(Integer.toString(gene+1));
	        ic.clearGraphData();

		float[][] dataMatrix=new float[(int)Math.sqrt(Na)][(int)Math.sqrt(Na)];
		for(int i=0;i<Math.sqrt(Na);i++){
		    for(int j=0;j<Math.sqrt(Na);j++){
			dataMatrix[i][j]=((float[][])dataArray.get(4))[i*(int)Math.sqrt(Na)+j][gene];
	            }
		}
                ic.setData(dataMatrix);

		right.setEnabled(gene!=(((float[][])dataArray.get(dataLabels[0]))[0].length-1));
                right.setVisible(true);
		left.setVisible(true);
		//right.setEnabled(gene!=(colToRow(((float[][])dataArray.get(dataLabels[0])),isCol).length-1));
		left.setEnabled(gene!=0);
	        label.setVisible(true);
	        ic.draw();
	        ic.repaint();
	        validate();
            }else{
                super.makeGraph();
	    }
	}catch(Exception e){
	    JOptionPane.showMessageDialog(this,e,"WARNING",JOptionPane.WARNING_MESSAGE);
	}
    }
}
