// Class: ZoomEvent
//
// Purpose: handle zoom event for ImageCanvas
//
// History:
//              v2.0, 17 Apr 99, mfo, Java2 version
//              9/23/99, jac, added boolean drag variable
//
// COPYRIGHT, 2000, Fox Chase Cancer Center
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

package viewer.csi.gui.event;

import java.util.EventObject;
import java.awt.Point;

public class ZoomEvent extends EventObject {

    public static int version = 200001;
    public static String copyright =
        "Copyright, 2000, Fox Chase Cancer Center";

    public static final int VECTOR = 1;
    public static final int BITMAP = 2;
    
    protected int zoomType;
    protected Point firstPoint;
    protected boolean flg;

    public ZoomEvent( Object source, Point newPoint, int newZoomType, boolean newFlg) {
        super( source );
        zoomType = newZoomType;
        firstPoint = newPoint;
	flg = newFlg;
    }
    
    public Point getFirstPoint() {
        return firstPoint;
    }
    
    public int getZoomType() {
        return zoomType;
    }

    public boolean getFlg() {
	return flg;
    }

}; // End of ZoomEvent.class


